//<c>   Copyright 1997-1998 by Gerry J. Danen; all rights reserved.

//<t>   Generate Maximus File Areas

//      Compiled with Microsoft C 8.00. Requires DANEN library to recompile.
//      Source released into the Public Domain.

//      %0 file-in file-out default-ACS default-upload-dir

//      file-in format:
//      name dlarea desc
//      NEW o:\fil\new\ New Files
//      =FileDivisionBegin <name> <rest of info>
//      =FileDivisionEnd
//      =Type

//FileArea NEW
//      ACS             Demoted *
//      Desc            New Files
//      Download        O:\FIL\NEW\                                         ;
//      Upload          O:\FIL\UNCHECK\ *                                   ;
//End FileArea

//      file-out format:
//      see FILEAREA.CTL


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_kb.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Generate File Area data to update FILEAREA.CTL in Maximus BBS"
#define pgCOPR_ "1997"


#define BUFSIZE 4096
FILE    *iFh, *oFh ;
UCHAR   iFile[FS_LEN], oFile[FS_LEN], work[BUFSIZE+2], *w,
        sACSdef[81], sDivACS[81], sACS[81],
        sUpload[FS_LEN*2], sDnload[FS_LEN*2], sDesc[256],
        sAreaName[81], sKW[256], sDivision[81], sType[256]="" ;
BOOL    inFileDivision = FALSE, createDirs = FALSE ;


void    ShowHelp( void )
{
    logon(1);
    printf( "\n\nUsage:  %s file_in file_out default_ACS default_upload_dir\n\n",
            get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    do_FileDivision( void )
{
    if ( st_eq(work, "=FileDivisionEnd") )
    {
        if ( inFileDivision )
        {
            inFileDivision = FALSE ;
            fprintf( oFh, "\nFileDivisionEnd\n" );
        }
        return ;
    }

    st_get_word( sKW, work );                   // get keyword
    st_remove_word( work );                     // remove word

    if ( st_eq(sKW, "=Type") )                  // set TYPE for file areas
    {
        ST_CPY( sType, work );
        return ;
    }

    if ( ! st_eq(sKW, "=FileDivisionBegin") )
        return ;

    if ( inFileDivision )                       // terminate division first
        fprintf( oFh, "\nFileDivisionEnd\n" );

    st_get_word( sDivision, work );             // get next word: division name
    st_remove_word( work );                     // remove word
    strupr( sDivision );
    st_get_word( sDivACS, work );               // get next word: division ACS
    st_remove_word( work );                     // remove word

    if ( strlen(sDivision) )
    {
        inFileDivision = TRUE ;
        fprintf( oFh, "\nFileDivisionBegin %s %s %s\n", sDivision, sDivACS, work );
        strupr( work );
        printf( "\n\nDivision %-13s %s", sDivision, work );
    }
}


BOOL    yn( STRING q )
{
    int ch ;

    fprintf( stderr, "\n%s: ", q );
    do  {
        ch = _getch();
        if ( ch == ESCAPE )
            ch = 'C' ;
    }   while ( StrFindChar( (UCHAR) ch, "YyNnCc" ) < 0 );
    if ( ch == 'c' || ch == 'C' )
    {
        fprintf( stderr, "Cancelled\n" );
        exit( GD_ERROR_USER_CANCEL );
    }
    fprintf( stderr, "%c\n\n", (char) ch );
    if ( ch == 'y' || ch == 'Y' )
        return( TRUE );
    return( FALSE );
}


void    main( int argc, char *argv[] )
{
    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 5 )
        ShowHelp();

    st_cpy( iFile, (UCHAR *) argv[1], FS_LEN );
    st_cpy( oFile, (UCHAR *) argv[2], FS_LEN );
    strupr( (char *) iFile );
    strupr( (char *) oFile );
    ST_CPY( sACSdef, (UCHAR *) argv[3] );
    ST_CPY( sUpload, (UCHAR *) argv[4] );
    strupr( (char *) sUpload );

    if ( ( iFh = fopen( iFile, "r" ) ) == NULL )
    {
        printf( "\n\nFile %s not found\a\n", iFile );
        ShowHelp();
    }

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

    createDirs = yn( "Create the directories? (Y/N/C)" );

    fprintf( oFh,
                ";\tGenerated by %s %s on %s %s %s\n"
                ";\t%s\n\n",
             get_global_program_name(), pgm_vers, TodaysDay(), TodaysDate(), TodaysTime(), pgm_copyrite );

    fprintf( stderr, "%s: reading %s ...", get_global_program_name(), iFile );

    while ( (w = fgets( work, BUFSIZE, iFh )) )
    {
        st_trim( work );
        if ( strlen(work) && (work[0] != ';') )
        {
            if ( work[0] == '=' )
            {
                do_FileDivision();
            }
            else
            {
                st_get_word( sAreaName, work ); // get first word: filearea name
                st_remove_word( work );         // remove word
                st_get_word( sDnload, work );   // get next word: download directory
                st_remove_word( work );         // remove word
                ST_CPY( sDesc, work );
                strupr( sDnload );
                strcpy( sACS, sACSdef );
                if ( inFileDivision && (!  st_eq(sDivACS, ".")) && strlen(sDivACS) )
                    strcpy( sACS, sDivACS );
                fprintf( oFh, "\nFileArea %s\n"
                              "\t%-16s%s\n"
                              "\t%-16s%s\n"
                              "\t%-16s%s\n"
                              "\t%-16s%s\n",
                              sAreaName, "ACS", sACS, "Desc", sDesc,
                              "Download", sDnload, "Upload", sUpload );
                if ( createDirs )
                {
                    dr_mkdir( sDnload, NO );
                    dr_mkdir( sUpload, NO );
                }
                if ( strlen(sType) )
                    fprintf( oFh, "\t%-16s%s\n", "Type", sType );
                fprintf( oFh, "End FileArea\n" );

                if ( inFileDivision )
                {
                    sprintf( work, "%s.%s", sDivision, sAreaName );
                    printf( "\n         %-15s %s", work, sDesc );
                }
                else
                    printf( "\nArea     %-15s %s", sAreaName, sDesc );
            }
        }
    }
    strcpy( work, "=FileDivisionEnd" );         // just in case we're in
    do_FileDivision();                          // a file division

    _fcloseall();
    printf( "\n" );
    fprintf( stderr, "\n%s created\n", oFile );

    exit( GD_ERROR_NONE );
}
